/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         __device_conf_parser_parse
#define yylex           __device_conf_parser_lex
#define yyerror         __device_conf_parser_error
#define yydebug         __device_conf_parser_debug
#define yynerrs         __device_conf_parser_nerrs

#define yylval          __device_conf_parser_lval
#define yychar          __device_conf_parser_char

/* Copy the first part of user declarations.  */
#line 1 "./osm_device_conf_parser_y.y" /* yacc.c:339  */

/*
 * Copyright (c) 2021-2025 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 * Copyright (c) 2021 Mellanox Technologies LTD. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

/*
 * Abstract:
 *    Grammar of OSM device configuration parser.
 *
 * Author:
 *    Or Nechemia, Mellanox
 */

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <opensm/osm_file_ids.h>
#define FILE_ID OSM_FILE_DEVICE_CONF_PARSER_Y_Y
#include <opensm/osm_opensm.h>

#define CHECK_PARAMS_PHYSP 	(uint8_t)1
#define CHECK_PARAMS_ALL 	(uint8_t)0xF

static void parser_tmp_struct_reset();
#define RESET_BUFFER  parser_tmp_struct_reset()

typedef enum vl_config_block_fields {
	VL_CONFIG_BLOCK_VL_BUFFER_WEIGHT,
	VL_CONFIG_BLOCK_DATA_TYPE_BITMASK,
	VL_CONFIG_BLOCK_DISABLE_HOQ_LIFE
} vl_config_block_fields_t;

typedef struct tmp_parser_struct_t_ {
	cl_list_t str_list;
	cl_list_t num_list;
	uint16_t num;
	boolean_t boolean;
} tmp_parser_struct_t;

static struct osm_opensm *p_osm;
char *__device_conf_parser_yylval = NULL;
extern FILE * __device_conf_parser_in;
tmp_parser_struct_t cap_tmp_parser_struct;
cl_list_t port_group_list;
osm_conf_params_physp_t cur_conf_params_physp;
osm_conf_params_node_t cur_conf_params_node;
static ib_qos_config_vl_t qos_config_vl_parsed;
static ib_port_recovery_policy_config_t port_recovery_policy_parsed;
static boolean_t is_qos_config_vl_parsed;
static boolean_t is_hoq_life_parsed = FALSE;
static boolean_t is_port_recovery_policy_parsed;
static uint8_t next_qos_qonfig_vl_profile_num = IB_QOS_CONFIG_VL_START_PROFILE;
static uint8_t next_port_recovery_policy_profile_num = IB_PORT_RECOVERY_POLICY_START_PROFILE;

int cap_column_num;
int cap_line_num;

static void parser_tmp_struct_init()
{
	cl_list_construct(&cap_tmp_parser_struct.str_list);
	cl_list_init(&cap_tmp_parser_struct.str_list, 10);
	cl_list_construct(&cap_tmp_parser_struct.num_list);
	cl_list_init(&cap_tmp_parser_struct.num_list, 10);
	cl_list_construct(&port_group_list);
	cl_list_init(&port_group_list, 10);
}

static void parser_tmp_struct_reset()
{
	cl_list_remove_all(&cap_tmp_parser_struct.str_list);
	cl_list_remove_all(&cap_tmp_parser_struct.num_list);
	cap_tmp_parser_struct.num = 0;
	cap_tmp_parser_struct.boolean = 0;
}

static void clear_tmp_num_list()
{
	cl_list_iterator_t list_iterator;
	uint64_t *p_num;

	for (list_iterator = cl_list_head(&cap_tmp_parser_struct.num_list);
	     list_iterator != cl_list_end(&cap_tmp_parser_struct.num_list);
	     list_iterator = cl_list_next(list_iterator)) {
		p_num = (uint64_t*)cl_list_obj(list_iterator);
		free(p_num);
	}
}

static void parser_tmp_struct_destroy()
{
	parser_tmp_struct_reset();
	cl_list_destroy(&cap_tmp_parser_struct.str_list);
	cl_list_destroy(&cap_tmp_parser_struct.num_list);
	cl_list_remove_all(&port_group_list);
	cl_list_destroy(&port_group_list);
}

static void set_non_default_conf_params_physp(osm_physp_t * p_physp, uint8_t qos_config_vl_profile, uint8_t port_recovery_policy_profile)
{
	if (cur_conf_params_physp.max_op_vl)
		p_physp->conf_params.max_op_vl = cur_conf_params_physp.max_op_vl;

	if (is_hoq_life_parsed)
		p_physp->conf_params.hoq_life = cur_conf_params_physp.hoq_life;

	/* Profiles supported only for switches */
	if (is_qos_config_vl_parsed && p_physp->p_node->sw)
		p_physp->conf_params.qos_config_vl_profile = qos_config_vl_profile;

	if (is_port_recovery_policy_parsed) {
		if (p_physp->p_node->sw) {
			p_physp->conf_params.port_recovery_policy_profile = port_recovery_policy_profile;
		} else {
			memcpy(&p_physp->conf_params.port_recovery_policy_config,
			       &port_recovery_policy_parsed, sizeof(ib_port_recovery_policy_config_t));

			/* Set draining_timeout to zero because its reserved for HCAs*/
			p_physp->conf_params.port_recovery_policy_config.draining_timeout = 0;
			p_physp->conf_params.is_port_recovery_policy_parsed = TRUE;
		}
	}
}

static void set_non_default_conf_params_node(osm_node_t * p_node)
{
	if (cur_conf_params_node.sharp_enabled)
		p_node->conf_params.sharp_enabled =
		    cur_conf_params_node.sharp_enabled;

	if (is_qos_config_vl_parsed) {
		if (p_node->p_gpu) {
			memcpy(&p_node->conf_params.qos_config_vl,
			       &qos_config_vl_parsed, sizeof(ib_qos_config_vl_t));
		} else if (p_node->sw) {
			/* Keep QoSConfigVL values per node and profile */
			memcpy(&p_node->sw->conf_params.qos_config_vl[next_qos_qonfig_vl_profile_num],
			       &qos_config_vl_parsed, sizeof(ib_qos_config_vl_t));

			if (p_node->sw->conf_params.qos_config_vl_max_profile < next_qos_qonfig_vl_profile_num) {
				p_node->sw->conf_params.qos_config_vl_max_profile = next_qos_qonfig_vl_profile_num;
			}
		}
		p_node->conf_params.is_qos_config_vl_parsed = TRUE;
	}

	if (is_port_recovery_policy_parsed) {
		if (p_node->sw) {
			/* Keep PortRecoveryPolicyConfig values per node and profile */
			memcpy(&p_node->sw->conf_params.port_recovery_policy_config[next_port_recovery_policy_profile_num],
			       &port_recovery_policy_parsed, sizeof(ib_port_recovery_policy_config_t));

			if (p_node->sw->conf_params.port_recovery_policy_max_profile < next_port_recovery_policy_profile_num) {
				p_node->sw->conf_params.port_recovery_policy_max_profile = next_port_recovery_policy_profile_num;
			}
		}
		p_node->conf_params.is_port_recovery_policy_parsed = TRUE;
	}
}

static void validae_pgrp_conf_params(osm_port_group_t * p_pgrp)
{
	if (is_hoq_life_parsed &&
	    cur_conf_params_physp.hoq_life > OSM_HOQ_LIFE_MAX_VALUE) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 9C10: "
			"HOQ Life of port group %s exceeds maximal value of 0x%x."
			"Setting HOQ Life to maximal value\n",
			p_pgrp->name, OSM_HOQ_LIFE_MAX_VALUE);

		cur_conf_params_physp.hoq_life = OSM_HOQ_LIFE_MAX_VALUE;
	}
}

static void configure_physps_conf_params(osm_port_group_t * p_pgrp)
{
	cl_map_item_t *p_item;
	osm_port_group_member_t *p_grp_m;
	osm_port_t *p_port;
	osm_physp_t *p_physp;
	int i;

	validae_pgrp_conf_params(p_pgrp);

	for (p_item = cl_qmap_head(&p_pgrp->ports);
	     p_item != cl_qmap_end(&p_pgrp->ports);
	     p_item = cl_qmap_next(p_item)) {
		p_grp_m = (osm_port_group_member_t *)p_item;
		p_port = p_grp_m->port;

		if (p_port->p_node->sw) {
			for (i = 1; i < p_port->p_node->physp_tbl_size; i++) {
				p_physp = osm_node_get_physp_ptr(p_port->p_node, i);

				if (p_grp_m->physp_members[i])
					set_non_default_conf_params_physp(p_physp, next_qos_qonfig_vl_profile_num,
									  next_port_recovery_policy_profile_num);
			}
			p_physp = &p_port->p_node->physp_table[0];
		} else {
			p_physp = p_port->p_physp;
			set_non_default_conf_params_physp(p_physp, 0, 0);
		}

		set_non_default_conf_params_node(p_physp->p_node);
	}
}

static void parser_conf_group_end()
{
	cl_list_iterator_t list_item;
	osm_port_group_t *p_cur_pgrp;

	for (list_item = cl_list_head(&port_group_list);
	     list_item != cl_list_end(&port_group_list);
	     list_item = cl_list_next(list_item)) {
		p_cur_pgrp = (osm_port_group_t *)cl_list_obj(list_item);
		if (p_cur_pgrp)
			configure_physps_conf_params(p_cur_pgrp);
	}

	memset((void *)&cur_conf_params_physp, 0, sizeof(cur_conf_params_physp));
	memset((void *)&cur_conf_params_node, 0, sizeof(cur_conf_params_node));
	memset((void *)&qos_config_vl_parsed, 0, sizeof(ib_qos_config_vl_t));
	memset((void *)&port_recovery_policy_parsed, 0, sizeof(ib_port_recovery_policy_config_t));
	is_hoq_life_parsed = FALSE;

	if (is_qos_config_vl_parsed) {
		next_qos_qonfig_vl_profile_num++;
		is_qos_config_vl_parsed = FALSE;
	}
	if (is_port_recovery_policy_parsed) {
		next_port_recovery_policy_profile_num++;
		is_port_recovery_policy_parsed = FALSE;
	}

	cl_list_remove_all(&port_group_list);
}

static int parse_vl_config_block_fields(ib_qos_config_vl_t *qos_config_vl, vl_config_block_fields_t parsed_field)
{
	ib_vl_config_block_t *p_vl_config_block;
	cl_list_iterator_t list_item;
	uint64_t *tmp_num;
	int status = 0;
	int i = 0;

	for (list_item = cl_list_head(&cap_tmp_parser_struct.num_list);
	     list_item != cl_list_end(&cap_tmp_parser_struct.num_list);
	     list_item = cl_list_next(list_item)) {
		tmp_num = (uint64_t *)cl_list_obj(list_item);
		p_vl_config_block = &qos_config_vl->vl_config_block[i++];
		switch (parsed_field) {
		case VL_CONFIG_BLOCK_VL_BUFFER_WEIGHT:
			p_vl_config_block->vl_buffer_weight = *tmp_num;
			break;
		case VL_CONFIG_BLOCK_DATA_TYPE_BITMASK:
			p_vl_config_block->data_type_bitmask = cl_hton16(*tmp_num);
			break;
		case VL_CONFIG_BLOCK_DISABLE_HOQ_LIFE:
			ib_qos_config_vl_set_disable_hoq_life(p_vl_config_block, *tmp_num);
			break;
		}
	}

	clear_tmp_num_list();
	cl_list_remove_all(&cap_tmp_parser_struct.num_list);
	return status;
}

static void clear_val(char **c)
{
	free(*c);
	*c = NULL;
}

static void yyerror(const char *format, ...)
{
	char s[256];
	va_list pvar;

	OSM_LOG_ENTER(&p_osm->log);

	va_start(pvar, format);
	vsnprintf(s, sizeof(s), format, pvar);
	va_end(pvar);

	OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 9C07: "
		"Syntax error (line %d:%d): %s\n",
		cap_line_num, cap_column_num, s);
	OSM_LOG_EXIT(&p_osm->log);
}

int __device_conf_parser_parse();
int __device_conf_parser_lex();

static void init_devices()
{
	osm_node_t *p_node;
	osm_physp_t *p_physp;
	uint8_t port_num;
	cl_map_item_t *p_next;

	p_next = cl_qmap_head(&p_osm->subn.node_guid_tbl);
	while (p_next != cl_qmap_end(&p_osm->subn.node_guid_tbl)) {
		p_node = (osm_node_t *)p_next;
		p_next = cl_qmap_next(p_next);

		/* Initialize node configuration parameters values */
		p_node->conf_params.sharp_enabled = 0;
		p_node->conf_params.is_qos_config_vl_parsed = FALSE;
		p_node->conf_params.is_port_recovery_policy_parsed = FALSE;
		memset(&p_node->conf_params.qos_config_vl, 0, sizeof(ib_qos_config_vl_t));

		if (p_node->sw) {
			memset(&p_node->sw->conf_params.qos_config_vl, 0,
			       (IB_PROFILE_CONFIG_MAX_PROFILE + 1) * sizeof(ib_qos_config_vl_t));
			p_node->sw->conf_params.qos_config_vl_max_profile = IB_QOS_CONFIG_VL_INVALID_PROFILE;
			memset(&p_node->sw->conf_params.port_recovery_policy_config, 0,
			       (IB_PROFILE_CONFIG_MAX_PROFILE + 1) * sizeof(ib_port_recovery_policy_config_t));
			p_node->sw->conf_params.port_recovery_policy_max_profile = IB_PORT_RECOVERY_POLICY_DEFAULT_PROFILE;
		}

		for (port_num = 1; port_num < osm_node_get_num_physp(p_node);
		     port_num++) {
			p_physp = osm_node_get_physp_ptr(p_node, port_num);
			if (!p_physp)
				continue;

			/* Initialize port configuration parameters values */
			p_physp->conf_params.max_op_vl = 0;
			p_physp->conf_params.hoq_life = OSM_HOQ_LIFE_INVALID;
			p_physp->conf_params.qos_config_vl_profile = IB_QOS_CONFIG_VL_INVALID_PROFILE;
			p_physp->conf_params.port_recovery_policy_profile = IB_PORT_RECOVERY_POLICY_DEFAULT_PROFILE;
			p_physp->conf_params.is_port_recovery_policy_parsed = FALSE;
			memset(&p_physp->conf_params.port_recovery_policy_config, 0, sizeof(ib_port_recovery_policy_config_t));
		}
	}
}

static void init_port_recovery_policy_values()
{
	is_port_recovery_policy_parsed = FALSE;
	next_port_recovery_policy_profile_num = IB_PORT_RECOVERY_POLICY_START_PROFILE;
	memset((void *)&port_recovery_policy_parsed, 0, sizeof(ib_port_recovery_policy_config_t));
}

int osm_parse_device_configuration_file(struct osm_opensm * osm_ptr)
{
	int res = 0;
	p_osm = osm_ptr;
	__device_conf_parser_in = NULL;
	parser_tmp_struct_init();
	cap_line_num = 0;
	cap_column_num = 0;
	is_qos_config_vl_parsed = FALSE;
	next_qos_qonfig_vl_profile_num = IB_QOS_CONFIG_VL_START_PROFILE;
	init_port_recovery_policy_values();

	init_devices();

	if (!p_osm->subn.opt.device_configuration_file) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 9C01: No device configuration file provided - "
			"Quit cap parser\n");
		res = 1;
		goto Exit;
	}

	__device_conf_parser_in = fopen(p_osm->subn.opt.device_configuration_file, "r");
	if (!__device_conf_parser_in) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 9C02: Device configuration file specified but not found\n");
		res = 1;
		goto Exit;
	}

        res = __device_conf_parser_parse();
	if (res)
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 9C03: Device configuration file parsing failed\n");
	else
		OSM_LOG(&p_osm->log, OSM_LOG_DEBUG, "Device configuration "
			"file parsed successfully\n");

Exit:
	if (__device_conf_parser_in) {
		fclose(__device_conf_parser_in);
		__device_conf_parser_in = NULL;
	}
	clear_val(&__device_conf_parser_yylval);
	parser_tmp_struct_destroy();
	return res;
}

#line 499 "./osm_device_conf_parser_y.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "osm_device_conf_parser_y.h".  */
#ifndef YY__DEVICE_CONF_PARSER_OSM_DEVICE_CONF_PARSER_Y_H_INCLUDED
# define YY__DEVICE_CONF_PARSER_OSM_DEVICE_CONF_PARSER_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int __device_conf_parser_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    COMMENT = 258,
    COMMA = 259,
    NUMBER = 260,
    TEXT = 261,
    TK_TRUE = 262,
    TK_FALSE = 263,
    PORT_CONF_START = 264,
    PORT_CONF_END = 265,
    PORT_GROUP_NAME = 266,
    GROUP_MAX_OP_VL = 267,
    GROUP_SHARP_ENABLED = 268,
    GROUP_HOQ_LIFE = 269,
    QOS_CONFIG_VL_START = 270,
    QOS_CONFIG_VL_END = 271,
    VL_BUFFER_WEIGHT = 272,
    DATA_TYPE_BITMASK = 273,
    DISABLE_HOQ_LIFE = 274,
    PORT_RECOVERY_POLICY_START = 275,
    PORT_RECOVERY_POLICY_END = 276,
    RECOVERY_TYPE_EN = 277,
    DRAINING_TIMEOUT = 278,
    LINK_DOWN_TIMEOUT = 279
  };
#endif
/* Tokens.  */
#define COMMENT 258
#define COMMA 259
#define NUMBER 260
#define TEXT 261
#define TK_TRUE 262
#define TK_FALSE 263
#define PORT_CONF_START 264
#define PORT_CONF_END 265
#define PORT_GROUP_NAME 266
#define GROUP_MAX_OP_VL 267
#define GROUP_SHARP_ENABLED 268
#define GROUP_HOQ_LIFE 269
#define QOS_CONFIG_VL_START 270
#define QOS_CONFIG_VL_END 271
#define VL_BUFFER_WEIGHT 272
#define DATA_TYPE_BITMASK 273
#define DISABLE_HOQ_LIFE 274
#define PORT_RECOVERY_POLICY_START 275
#define PORT_RECOVERY_POLICY_END 276
#define RECOVERY_TYPE_EN 277
#define DRAINING_TIMEOUT 278
#define LINK_DOWN_TIMEOUT 279

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE __device_conf_parser_lval;

int __device_conf_parser_parse (void);

#endif /* !YY__DEVICE_CONF_PARSER_OSM_DEVICE_CONF_PARSER_Y_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 598 "./osm_device_conf_parser_y.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   40

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  25
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  43
/* YYNRULES -- Number of rules.  */
#define YYNRULES  64
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  80

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   279

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   452,   452,   454,   455,   458,   460,   461,   488,   490,
     492,   496,   497,   500,   501,   502,   503,   504,   505,   506,
     518,   542,   546,   547,   550,   561,   565,   569,   574,   578,
     583,   587,   591,   605,   624,   625,   628,   629,   630,   631,
     634,   647,   651,   664,   668,   681,   685,   689,   708,   709,
     712,   713,   714,   715,   718,   723,   728,   733,   734,   737,
     749,   749,   749,   751,   755
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "COMMENT", "COMMA", "NUMBER", "TEXT",
  "TK_TRUE", "TK_FALSE", "PORT_CONF_START", "PORT_CONF_END",
  "PORT_GROUP_NAME", "GROUP_MAX_OP_VL", "GROUP_SHARP_ENABLED",
  "GROUP_HOQ_LIFE", "QOS_CONFIG_VL_START", "QOS_CONFIG_VL_END",
  "VL_BUFFER_WEIGHT", "DATA_TYPE_BITMASK", "DISABLE_HOQ_LIFE",
  "PORT_RECOVERY_POLICY_START", "PORT_RECOVERY_POLICY_END",
  "RECOVERY_TYPE_EN", "DRAINING_TIMEOUT", "LINK_DOWN_TIMEOUT", "$accept",
  "cap_policy", "configurations", "comment", "configuration", "conf_group",
  "conf_group_start", "conf_group_end", "conf_group_entries",
  "conf_group_entry", "port_group_name", "port_group_name_start",
  "string_list", "single_string", "max_op_vl", "max_op_vl_start",
  "hoq_life", "hoq_life_start", "number", "sharp_enabled",
  "sharp_enabled_start", "port_recovery_policy",
  "port_recovery_policy_start", "port_recovery_policy_entries",
  "port_recovery_policy_entry", "recovery_type_en",
  "recovery_type_en_start", "draining_timeout", "draining_timeout_start",
  "link_down_timeout", "link_down_timeout_start", "qos_config_vl",
  "qos_config_vl_start", "qos_config_vl_entries", "qos_config_vl_entry",
  "vl_buffer_weight", "data_type_bitmask", "disable_hoq_life", "num_list",
  "single_number", "bool", "true", "false", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279
};
# endif

#define YYPACT_NINF -58

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-58)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -58,     8,     1,   -58,   -58,   -58,   -58,   -58,   -58,   -58,
       4,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,
     -58,   -58,     3,   -58,     6,   -58,     6,   -58,    32,   -58,
     -58,   -58,   -58,   -58,    25,   -58,   -58,   -58,   -58,   -58,
     -58,   -58,   -58,   -58,   -58,    -1,     9,     3,   -58,   -58,
     -58,   -58,   -58,   -58,   -58,     6,   -58,     6,   -58,     6,
     -58,    26,    26,    26,   -58,   -58,   -58,   -58,   -58,   -58,
     -58,   -58,   -58,   -58,    29,   -58,    29,    29,    26,   -58
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     2,     1,     5,     9,     7,     4,     6,    11,
       0,    10,    21,    26,    31,    28,    47,    33,    19,     8,
      12,    13,     0,    14,     0,    16,     0,    15,     0,    18,
      34,    17,    48,    24,    20,    22,    29,    25,    27,    63,
      64,    60,    30,    61,    62,     0,     0,     0,    32,    41,
      43,    45,    39,    35,    36,     0,    37,     0,    38,     0,
      46,     0,     0,     0,    53,    49,    50,    51,    52,    23,
      40,    42,    44,    59,    54,    57,    55,    56,     0,    58
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -58,   -58,   -58,   -10,   -58,   -58,   -58,   -58,   -58,   -58,
     -58,   -58,   -58,   -34,   -58,   -58,   -58,   -58,   -25,   -58,
     -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,
     -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -57,   -40,
     -58,   -58,   -58
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,     6,     7,     8,     9,    19,    10,    20,
      21,    22,    34,    35,    23,    24,    25,    26,    37,    27,
      28,    29,    30,    45,    53,    54,    55,    56,    57,    58,
      59,    31,    32,    46,    65,    66,    67,    68,    74,    75,
      42,    43,    44
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      18,    38,     4,    41,     4,    76,    77,     4,     3,    33,
       5,    36,     4,    69,    11,    12,    13,    14,    15,    16,
      48,    49,    50,    51,    17,    60,    61,    62,    63,    47,
      70,    73,    71,    78,    72,    52,    64,    36,    79,    39,
      40
};

static const yytype_uint8 yycheck[] =
{
      10,    26,     3,    28,     3,    62,    63,     3,     0,     6,
       9,     5,     3,    47,    10,    11,    12,    13,    14,    15,
      21,    22,    23,    24,    20,    16,    17,    18,    19,     4,
      55,     5,    57,     4,    59,    45,    46,     5,    78,     7,
       8
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    26,    27,     0,     3,     9,    28,    29,    30,    31,
      33,    10,    11,    12,    13,    14,    15,    20,    28,    32,
      34,    35,    36,    39,    40,    41,    42,    44,    45,    46,
      47,    56,    57,     6,    37,    38,     5,    43,    43,     7,
       8,    43,    65,    66,    67,    48,    58,     4,    21,    22,
      23,    24,    28,    49,    50,    51,    52,    53,    54,    55,
      16,    17,    18,    19,    28,    59,    60,    61,    62,    38,
      43,    43,    43,     5,    63,    64,    63,    63,     4,    64
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    25,    26,    27,    27,    28,    29,    29,    30,    31,
      32,    33,    33,    34,    34,    34,    34,    34,    34,    34,
      35,    36,    37,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    48,    49,    49,    49,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    58,
      59,    59,    59,    59,    60,    61,    62,    63,    63,    64,
      65,    65,    65,    66,    67
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     3,     1,
       1,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     3,     1,     2,     1,     2,     1,     1,
       2,     1,     3,     1,     0,     2,     1,     1,     1,     1,
       2,     1,     2,     1,     2,     1,     3,     1,     0,     2,
       1,     1,     1,     1,     2,     2,     2,     1,     3,     1,
       1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 458 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {}
#line 1740 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 9:
#line 490 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {}
#line 1746 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 10:
#line 492 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		parser_conf_group_end();
	}
#line 1754 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 20:
#line 518 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		cl_list_iterator_t list_item;
		char *tmp_str;
		osm_port_group_t *p_port_grp;

		for (list_item = cl_list_head(&cap_tmp_parser_struct.str_list);
		     list_item != cl_list_end(&cap_tmp_parser_struct.str_list);
		     list_item = cl_list_next(list_item)) {
			tmp_str = (char *)cl_list_obj(list_item);
			if (tmp_str) {
				p_port_grp = osm_get_port_grp(p_osm, tmp_str);
				if (p_port_grp) {
					cl_list_insert_tail(&port_group_list, p_port_grp);
				} else {
					OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 9C04: "
						"Port group with name (%s) does not exist\n",
						tmp_str);
				}
			}
			free(tmp_str);
		}
		cl_list_remove_all(&cap_tmp_parser_struct.str_list);
	}
#line 1782 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 21:
#line 542 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		RESET_BUFFER;
	}
#line 1790 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 24:
#line 550 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		char *tmp_str = strdup(__device_conf_parser_yylval);
		if (!tmp_str) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
				"ERR 9C05: Couldn't allocate memory for "
				"port group name, Aborting parsing\n");
			return 1;
		}
		cl_list_insert_tail(&cap_tmp_parser_struct.str_list, tmp_str);
	}
#line 1805 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 25:
#line 561 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		cur_conf_params_physp.max_op_vl = cap_tmp_parser_struct.num;
	}
#line 1813 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 26:
#line 565 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		RESET_BUFFER;
	}
#line 1821 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 27:
#line 569 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		cur_conf_params_physp.hoq_life = cap_tmp_parser_struct.num;
		is_hoq_life_parsed = TRUE;
	}
#line 1830 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 28:
#line 574 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		RESET_BUFFER;
	}
#line 1838 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 29:
#line 578 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		cap_tmp_parser_struct.num = strtoull(__device_conf_parser_yylval, NULL, 0);
		cap_tmp_parser_struct.boolean = (cap_tmp_parser_struct.num > 0);
	}
#line 1847 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 30:
#line 583 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		cur_conf_params_node.sharp_enabled = cap_tmp_parser_struct.boolean ? 2 : 1;
	}
#line 1855 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 31:
#line 587 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		RESET_BUFFER;
	}
#line 1863 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 32:
#line 591 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		uint16_t link_down_timeout_ho = cl_ntoh16(port_recovery_policy_parsed.link_down_timeout);

		if (port_recovery_policy_parsed.draining_timeout > link_down_timeout_ho) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
				"ERR 9C0B: Invalid port recovery policy configuration. "
				"draining_timeout (%d) must be equal or less then link_down_timeout (%d).\n",
				port_recovery_policy_parsed.draining_timeout,
				link_down_timeout_ho);
			return 1;
		}
		is_port_recovery_policy_parsed = TRUE;
	}
#line 1881 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 33:
#line 605 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		if (is_port_recovery_policy_parsed) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
				"ERR 9C09: port_recovery_policy section already parsed for the current port group\n");
			return 1;
		}

		/*
		 * HACK: limit to maximum of 8 profiles. Profile zero is reserved for unconfigured ports.
		 * Later should limit to 8 per switch.
		 */
		if (next_port_recovery_policy_profile_num > IB_PROFILE_CONFIG_MAX_PROFILE) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 9C0A: "
				"Device configuration parser supports up to %d sections of port_recovery_policy. "
				"Aborting parsing\n", IB_PROFILE_CONFIG_MAX_PROFILE);
			return 1;
		}
	}
#line 1904 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 40:
#line 634 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
	uint16_t recovery_type_en = cap_tmp_parser_struct.num;
	if (recovery_type_en > 0xF) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 9C0C: Invalid port recovery policy configuration. "
			"recovery_type_en 0x%x is invalid, supported bits are 0-3 (0xF)\n",
			recovery_type_en);
		return 1;
	}

	port_recovery_policy_parsed.recovery_type_en = cl_hton16(recovery_type_en);
}
#line 1921 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 41:
#line 647 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
	RESET_BUFFER;
}
#line 1929 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 42:
#line 651 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
	uint16_t draining_timeout = cap_tmp_parser_struct.num;
	if (draining_timeout > 100) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 9C0D: Invalid port recovery policy configuration. "
			"draining_timeout %d is invalid, must be in 0-100 range\n",
			draining_timeout);
		return 1;
	}

	port_recovery_policy_parsed.draining_timeout = draining_timeout;
}
#line 1946 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 43:
#line 664 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
	RESET_BUFFER;
}
#line 1954 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 44:
#line 668 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
	uint16_t link_down_timeout = cap_tmp_parser_struct.num;
	if (link_down_timeout > 3000) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 9C0E: Invalid port recovery policy configuration. "
			"link_down_timeout %d is invalid, must be in 0-3000 range\n",
			link_down_timeout);
		return 1;
	}

	port_recovery_policy_parsed.link_down_timeout = cl_hton16(link_down_timeout);
}
#line 1971 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 45:
#line 681 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
	RESET_BUFFER;
}
#line 1979 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 46:
#line 685 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		is_qos_config_vl_parsed = TRUE;
	}
#line 1987 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 47:
#line 689 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		if (is_qos_config_vl_parsed) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
				"ERR 9C06: qos_config_vl section already parsed for the current port group\n");
			return 1;
		}

		/*
		 * HACK: limit to maximum of 8 profiles. Profile zero is reserved for unconfigured ports.
		 * Later should limit to 8 per switch.
		 */
		if (next_qos_qonfig_vl_profile_num > IB_PROFILE_CONFIG_MAX_PROFILE) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 9C07: "
				"Device configuration parser supports up to %d sections of qos_config_vl. "
				"Aborting parsing\n", IB_PROFILE_CONFIG_MAX_PROFILE);
			return 1;
		}
	}
#line 2010 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 54:
#line 718 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
	if (parse_vl_config_block_fields(&qos_config_vl_parsed, VL_CONFIG_BLOCK_VL_BUFFER_WEIGHT))
		return 1;
}
#line 2019 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 55:
#line 723 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
	if (parse_vl_config_block_fields(&qos_config_vl_parsed, VL_CONFIG_BLOCK_DATA_TYPE_BITMASK))
		return 1;
}
#line 2028 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 56:
#line 728 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
	if (parse_vl_config_block_fields(&qos_config_vl_parsed, VL_CONFIG_BLOCK_DISABLE_HOQ_LIFE))
		return 1;
}
#line 2037 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 59:
#line 737 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		uint64_t *p_num = (uint64_t *) calloc(1, sizeof(uint64_t));
		if (!p_num) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
				"ERR 9C08: Couldn't allocate memory, Aborting parsing\n");
			return 1;
		}

		*p_num = strtoull(__device_conf_parser_yylval, NULL, 0);
		cl_list_insert_tail(&cap_tmp_parser_struct.num_list, p_num);
	}
#line 2053 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 62:
#line 749 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {}
#line 2059 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 63:
#line 751 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		cap_tmp_parser_struct.boolean = 1;
	}
#line 2067 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;

  case 64:
#line 755 "./osm_device_conf_parser_y.y" /* yacc.c:1646  */
    {
		cap_tmp_parser_struct.boolean = 0;
	}
#line 2075 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
    break;


#line 2079 "./osm_device_conf_parser_y.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 759 "./osm_device_conf_parser_y.y" /* yacc.c:1906  */

